diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-rrc-sap.h ns-3.31/src/lte/model/lte-rrc-sap.h
--- ns-3.30.1/src/lte/model/lte-rrc-sap.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-rrc-sap.h	2020-06-27 17:38:30.000000000 -0700
@@ -88,7 +88,7 @@
   struct FreqInfo
   {
     uint32_t ulCarrierFreq; ///< UL carrier frequency
-    uint8_t ulBandwidth; ///< UL bandwidth
+    uint16_t ulBandwidth; ///< UL bandwidth
   };
 
   /// RlcConfig structure
@@ -121,7 +121,7 @@
     {
       SETUP, RESET
     } type; ///< action type
-    uint8_t srsBandwidthConfig; ///< SRS bandwidth config
+    uint16_t srsBandwidthConfig; ///< SRS bandwidth config
     uint8_t srsSubframeConfig; ///< SRS subframe config
   };
 
@@ -133,7 +133,7 @@
     {
       SETUP, RESET
     } type; ///< action type
-    uint8_t srsBandwidth; ///< SRS bandwidth
+    uint16_t srsBandwidth; ///< SRS bandwidth
     uint16_t srsConfigIndex; ///< SRS config index
   };
 
@@ -325,7 +325,7 @@
   struct MeasObjectEutra
   {
     uint32_t carrierFreq; ///< carrier frequency
-    uint8_t allowedMeasBandwidth; ///< allowed measure bandwidth
+    uint16_t allowedMeasBandwidth; ///< allowed measure bandwidth
     bool presenceAntennaPort1; ///< antenna port 1 present?
     uint8_t neighCellConfig; ///< neighbor cell config
     int8_t offsetFreq; ///< offset frequency
@@ -543,8 +543,8 @@
   /// CarrierBandwidthEutra structure
   struct CarrierBandwidthEutra
   {
-    uint8_t dlBandwidth; ///< DL bandwidth
-    uint8_t ulBandwidth; ///< UL bandwidth
+    uint16_t dlBandwidth; ///< DL bandwidth
+    uint16_t ulBandwidth; ///< UL bandwidth
   };
 
   /// RachConfigDedicated structure
@@ -586,8 +586,8 @@
   /// MasterInformationBlock structure
   struct MasterInformationBlock
   {
-    uint8_t dlBandwidth; ///< DL bandwidth
-    uint8_t systemFrameNumber; ///< system frame number
+    uint16_t dlBandwidth; ///< DL bandwidth
+    uint16_t systemFrameNumber; ///< system frame number
   };
 
   /// SystemInformationBlockType1 structure
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-spectrum-signal-parameters.cc ns-3.31/src/lte/model/lte-spectrum-signal-parameters.cc
--- ns-3.30.1/src/lte/model/lte-spectrum-signal-parameters.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-spectrum-signal-parameters.cc	2020-06-27 17:38:30.000000000 -0700
@@ -46,14 +46,7 @@
 LteSpectrumSignalParameters::Copy ()
 {
   NS_LOG_FUNCTION (this);
-  // Ideally we would use:
-  //   return Copy<LteSpectrumSignalParameters> (*this);
-  // but for some reason it doesn't work. Another alternative is 
-  //   return Copy<LteSpectrumSignalParameters> (this);
-  // but it causes a double creation of the object, hence it is less efficient.
-  // The solution below is copied from the implementation of Copy<> (Ptr<>) in ptr.h
-  Ptr<LteSpectrumSignalParameters> lssp (new LteSpectrumSignalParameters (*this), false);  
-  return lssp;
+  return Create<LteSpectrumSignalParameters> (*this);
 }
 
 
@@ -79,14 +72,7 @@
 LteSpectrumSignalParametersDataFrame::Copy ()
 {
   NS_LOG_FUNCTION (this);
-  // Ideally we would use:
-  //   return Copy<LteSpectrumSignalParametersDataFrame> (*this);
-  // but for some reason it doesn't work. Another alternative is 
-  //   return Copy<LteSpectrumSignalParametersDataFrame> (this);
-  // but it causes a double creation of the object, hence it is less efficient.
-  // The solution below is copied from the implementation of Copy<> (Ptr<>) in ptr.h
-  Ptr<LteSpectrumSignalParametersDataFrame> lssp (new LteSpectrumSignalParametersDataFrame (*this), false);  
-  return lssp;
+  return Create<LteSpectrumSignalParametersDataFrame> (*this);
 }
 
 
@@ -109,14 +95,7 @@
 LteSpectrumSignalParametersDlCtrlFrame::Copy ()
 {
   NS_LOG_FUNCTION (this);
-  // Ideally we would use:
-  //   return Copy<LteSpectrumSignalParametersDlCtrlFrame> (*this);
-  // but for some reason it doesn't work. Another alternative is 
-  //   return Copy<LteSpectrumSignalParametersDlCtrlFrame> (this);
-  // but it causes a double creation of the object, hence it is less efficient.
-  // The solution below is copied from the implementation of Copy<> (Ptr<>) in ptr.h
-  Ptr<LteSpectrumSignalParametersDlCtrlFrame> lssp (new LteSpectrumSignalParametersDlCtrlFrame (*this), false);  
-  return lssp;
+  return Create<LteSpectrumSignalParametersDlCtrlFrame> (*this);
 }
 
 
@@ -136,14 +115,7 @@
 LteSpectrumSignalParametersUlSrsFrame::Copy ()
 {
   NS_LOG_FUNCTION (this);
-  // Ideally we would use:
-  //   return Copy<LteSpectrumSignalParametersUlSrsFrame> (*this);
-  // but for some reason it doesn't work. Another alternative is 
-  //   return Copy<LteSpectrumSignalParametersUlSrsFrame> (this);
-  // but it causes a double creation of the object, hence it is less efficient.
-  // The solution below is copied from the implementation of Copy<> (Ptr<>) in ptr.h
-  Ptr<LteSpectrumSignalParametersUlSrsFrame> lssp (new LteSpectrumSignalParametersUlSrsFrame (*this), false);  
-  return lssp;
+  return Create<LteSpectrumSignalParametersUlSrsFrame> (*this);
 }
 
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-spectrum-value-helper.cc ns-3.31/src/lte/model/lte-spectrum-value-helper.cc
--- ns-3.30.1/src/lte/model/lte-spectrum-value-helper.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-spectrum-value-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -173,9 +173,9 @@
 }
 
 double 
-LteSpectrumValueHelper::GetChannelBandwidth (uint8_t transmissionBandwidth)
+LteSpectrumValueHelper::GetChannelBandwidth (uint16_t transmissionBandwidth)
 {
-  NS_LOG_FUNCTION ((uint16_t) transmissionBandwidth);
+  NS_LOG_FUNCTION (transmissionBandwidth);
   switch (transmissionBandwidth)
     { 
     case 6:
@@ -191,7 +191,7 @@
     case 100:
       return 20.0e6;
     default:
-      NS_FATAL_ERROR ("invalid bandwidth value " << (uint16_t) transmissionBandwidth);
+      NS_FATAL_ERROR ("invalid bandwidth value " << transmissionBandwidth);
     }
 }
 
@@ -209,7 +209,7 @@
    */
   LteSpectrumModelId (uint32_t f, uint8_t b);
   uint32_t earfcn; ///< EARFCN
-  uint8_t  bandwidth; ///< bandwidth
+  uint16_t  bandwidth; ///< bandwidth
 };
 
 LteSpectrumModelId::LteSpectrumModelId (uint32_t f, uint8_t b)
@@ -236,9 +236,9 @@
 
 
 Ptr<SpectrumModel>
-LteSpectrumValueHelper::GetSpectrumModel (uint32_t earfcn, uint8_t txBandwidthConfiguration)
+LteSpectrumValueHelper::GetSpectrumModel (uint32_t earfcn, uint16_t txBandwidthConfiguration)
 {
-  NS_LOG_FUNCTION (earfcn << (uint16_t) txBandwidthConfiguration);
+  NS_LOG_FUNCTION (earfcn << txBandwidthConfiguration);
   Ptr<SpectrumModel> ret;
   LteSpectrumModelId key (earfcn, txBandwidthConfiguration);
   std::map<LteSpectrumModelId, Ptr<SpectrumModel> >::iterator it = g_lteSpectrumModelMap.find (key);
@@ -271,9 +271,9 @@
 }
 
 Ptr<SpectrumValue> 
-LteSpectrumValueHelper::CreateTxPowerSpectralDensity (uint32_t earfcn, uint8_t txBandwidthConfiguration, double powerTx, std::vector <int> activeRbs)
+LteSpectrumValueHelper::CreateTxPowerSpectralDensity (uint32_t earfcn, uint16_t txBandwidthConfiguration, double powerTx, std::vector <int> activeRbs)
 {
-  NS_LOG_FUNCTION (earfcn << (uint16_t) txBandwidthConfiguration << powerTx << activeRbs);
+  NS_LOG_FUNCTION (earfcn << txBandwidthConfiguration << powerTx << activeRbs);
 
   Ptr<SpectrumModel> model = GetSpectrumModel (earfcn, txBandwidthConfiguration);
   Ptr<SpectrumValue> txPsd = Create <SpectrumValue> (model);
@@ -295,9 +295,9 @@
 }
 
 Ptr<SpectrumValue>
-LteSpectrumValueHelper::CreateTxPowerSpectralDensity (uint32_t earfcn, uint8_t txBandwidthConfiguration, double powerTx, std::map<int, double> powerTxMap, std::vector <int> activeRbs)
+LteSpectrumValueHelper::CreateTxPowerSpectralDensity (uint32_t earfcn, uint16_t txBandwidthConfiguration, double powerTx, std::map<int, double> powerTxMap, std::vector <int> activeRbs)
 {
-  NS_LOG_FUNCTION (earfcn << (uint16_t) txBandwidthConfiguration << activeRbs);
+  NS_LOG_FUNCTION (earfcn << txBandwidthConfiguration << activeRbs);
 
   Ptr<SpectrumModel> model = GetSpectrumModel (earfcn, txBandwidthConfiguration);
   Ptr<SpectrumValue> txPsd = Create <SpectrumValue> (model);
@@ -333,9 +333,9 @@
 }
 
 Ptr<SpectrumValue>
-LteSpectrumValueHelper::CreateUlTxPowerSpectralDensity (uint16_t earfcn, uint8_t txBandwidthConfiguration, double powerTx, std::vector <int> activeRbs)
+LteSpectrumValueHelper::CreateUlTxPowerSpectralDensity (uint16_t earfcn, uint16_t txBandwidthConfiguration, double powerTx, std::vector <int> activeRbs)
 {
-  NS_LOG_FUNCTION (earfcn << (uint16_t) txBandwidthConfiguration << powerTx << activeRbs);
+  NS_LOG_FUNCTION (earfcn << txBandwidthConfiguration << powerTx << activeRbs);
 
   Ptr<SpectrumModel> model = GetSpectrumModel (earfcn, txBandwidthConfiguration);
   Ptr<SpectrumValue> txPsd = Create <SpectrumValue> (model);
@@ -357,9 +357,9 @@
 }
 
 Ptr<SpectrumValue>
-LteSpectrumValueHelper::CreateNoisePowerSpectralDensity (uint32_t earfcn, uint8_t txBandwidthConfiguration, double noiseFigure)
+LteSpectrumValueHelper::CreateNoisePowerSpectralDensity (uint32_t earfcn, uint16_t txBandwidthConfiguration, double noiseFigure)
 {
-  NS_LOG_FUNCTION (earfcn << (uint16_t) txBandwidthConfiguration << noiseFigure);
+  NS_LOG_FUNCTION (earfcn << txBandwidthConfiguration << noiseFigure);
   Ptr<SpectrumModel> model = GetSpectrumModel (earfcn, txBandwidthConfiguration);
   return CreateNoisePowerSpectralDensity (noiseFigure, model);
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-spectrum-value-helper.h ns-3.31/src/lte/model/lte-spectrum-value-helper.h
--- ns-3.30.1/src/lte/model/lte-spectrum-value-helper.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-spectrum-value-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -95,7 +95,7 @@
    *
    * \return the nominal channel bandwidth in Hz as per 3GPP TS 36.101
    */
-  static double GetChannelBandwidth (uint8_t txBandwidthConf);
+  static double GetChannelBandwidth (uint16_t txBandwidthConf);
 
   /**
    *
@@ -109,7 +109,7 @@
    * configuration. If such SpectrumModel does not exist, it is
    * created.
    */
-  static Ptr<SpectrumModel> GetSpectrumModel (uint32_t earfcn, uint8_t bandwidth);
+  static Ptr<SpectrumModel> GetSpectrumModel (uint32_t earfcn, uint16_t bandwidth);
 
 
   /**
@@ -126,7 +126,7 @@
    * \return a pointer to a newly allocated SpectrumValue representing the TX Power Spectral Density in W/Hz for each Resource Block
    */
   static Ptr<SpectrumValue> CreateTxPowerSpectralDensity (uint32_t earfcn,
-                                                          uint8_t bandwidth,
+                                                          uint16_t bandwidth,
                                                           double powerTx,
                                                           std::vector <int> activeRbs);
 
@@ -147,7 +147,7 @@
    * \return a pointer to a newly allocated SpectrumValue representing the TX Power Spectral Density in W/Hz for each Resource Block
    */
   static Ptr<SpectrumValue> CreateTxPowerSpectralDensity (uint32_t earfcn,
-                                                          uint8_t bandwidth,
+                                                          uint16_t bandwidth,
                                                           double powerTx,
                                                           std::map<int, double> powerTxMap,
                                                           std::vector <int> activeRbs);
@@ -167,7 +167,7 @@
    * \return a pointer to a newly allocated SpectrumValue representing the TX Power Spectral Density in W/Hz for each Resource Block
    */
   static Ptr<SpectrumValue> CreateUlTxPowerSpectralDensity (uint16_t earfcn,
-                                                            uint8_t bandwidth,
+                                                            uint16_t bandwidth,
                                                             double powerTx,
                                                             std::vector <int> activeRbs);
 
@@ -182,7 +182,7 @@
    *
    * \return a pointer to a newly allocated SpectrumValue representing the noise Power Spectral Density in W/Hz for each Resource Block
    */
-  static Ptr<SpectrumValue> CreateNoisePowerSpectralDensity (uint32_t earfcn, uint8_t bandwidth, double noiseFigure);
+  static Ptr<SpectrumValue> CreateNoisePowerSpectralDensity (uint32_t earfcn, uint16_t bandwidth, double noiseFigure);
 
   /**
    *  create a SpectrumValue that models the power spectral density of AWGN
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ue-cphy-sap.h ns-3.31/src/lte/model/lte-ue-cphy-sap.h
--- ns-3.30.1/src/lte/model/lte-ue-cphy-sap.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ue-cphy-sap.h	2020-06-27 17:38:30.000000000 -0700
@@ -106,7 +106,7 @@
   /**
    * \param dlBandwidth the DL bandwidth in number of PRBs
    */
-  virtual void SetDlBandwidth (uint8_t dlBandwidth) = 0;
+  virtual void SetDlBandwidth (uint16_t dlBandwidth) = 0;
 
   /** 
    * \brief Configure uplink (normally done after reception of SIB2)
@@ -114,7 +114,7 @@
    * \param ulEarfcn the uplink carrier frequency (EARFCN)
    * \param ulBandwidth the UL bandwidth in number of PRBs
    */
-  virtual void ConfigureUplink (uint32_t ulEarfcn, uint8_t ulBandwidth) = 0;
+  virtual void ConfigureUplink (uint32_t ulEarfcn, uint16_t ulBandwidth) = 0;
 
   /**
    * \brief Configure referenceSignalPower
@@ -316,8 +316,8 @@
   virtual void StartCellSearch (uint32_t dlEarfcn);
   virtual void SynchronizeWithEnb (uint16_t cellId);
   virtual void SynchronizeWithEnb (uint16_t cellId, uint32_t dlEarfcn);
-  virtual void SetDlBandwidth (uint8_t dlBandwidth);
-  virtual void ConfigureUplink (uint32_t ulEarfcn, uint8_t ulBandwidth);
+  virtual void SetDlBandwidth (uint16_t dlBandwidth);
+  virtual void ConfigureUplink (uint32_t ulEarfcn, uint16_t ulBandwidth);
   virtual void ConfigureReferenceSignalPower (int8_t referenceSignalPower);
   virtual void SetRnti (uint16_t rnti);
   virtual void SetTransmissionMode (uint8_t txMode);
@@ -375,14 +375,14 @@
 
 template <class C>
 void
-MemberLteUeCphySapProvider<C>::SetDlBandwidth (uint8_t dlBandwidth)
+MemberLteUeCphySapProvider<C>::SetDlBandwidth (uint16_t dlBandwidth)
 {
   m_owner->DoSetDlBandwidth (dlBandwidth);
 }
 
 template <class C>
 void 
-MemberLteUeCphySapProvider<C>::ConfigureUplink (uint32_t ulEarfcn, uint8_t ulBandwidth)
+MemberLteUeCphySapProvider<C>::ConfigureUplink (uint32_t ulEarfcn, uint16_t ulBandwidth)
 {
   m_owner->DoConfigureUplink (ulEarfcn, ulBandwidth);
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ue-phy.cc ns-3.31/src/lte/model/lte-ue-phy.cc
--- ns-3.30.1/src/lte/model/lte-ue-phy.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ue-phy.cc	2020-06-27 17:38:30.000000000 -0700
@@ -268,6 +268,14 @@
                    UintegerValue (1),
                    MakeUintegerAccessor (&LteUePhy::m_rsrpSinrSamplePeriod),
                    MakeUintegerChecker<uint16_t> ())
+    .AddTraceSource ("ReportUlPhyResourceBlocks",
+                     "UL transmission PHY layer resource blocks.",
+                     MakeTraceSourceAccessor (&LteUePhy::m_reportUlPhyResourceBlocks),
+                     "ns3::LteUePhy::UlPhyResourceBlocksTracedCallback")
+    .AddTraceSource ("ReportPowerSpectralDensity",
+                     "Power Spectral Density data.",
+                     MakeTraceSourceAccessor (&LteUePhy::m_reportPowerSpectralDensity),
+                     "ns3::LteUePhy::PowerSpectralDensityTracedCallback")
     .AddTraceSource ("UlPhyTransmission",
                      "DL transmission PHY layer statistics.",
                      MakeTraceSourceAccessor (&LteUePhy::m_ulPhyTransmission),
@@ -541,6 +549,7 @@
   NS_LOG_FUNCTION (this);
   LteSpectrumValueHelper psdHelper;
   Ptr<SpectrumValue> psd = psdHelper.CreateUlTxPowerSpectralDensity (m_ulEarfcn, m_ulBandwidth, m_txPower, GetSubChannelsForTransmission ());
+  m_reportPowerSpectralDensity (m_rnti, psd);
 
   return psd;
 }
@@ -1096,6 +1105,7 @@
               ulRb.push_back (i + dci.m_rbStart);
               //NS_LOG_DEBUG (this << " UE RB " << i + dci.m_rbStart);
             }
+          m_reportUlPhyResourceBlocks (m_rnti, ulRb);
           QueueSubChannelsForTransmission (ulRb);
           // fire trace of UL Tx PHY stats
           HarqProcessInfoList_t harqInfoList = m_harqPhyModule->GetHarqProcessInfoUl (m_rnti, 0);
@@ -1434,7 +1444,7 @@
 }
 
 void
-LteUePhy::DoSetDlBandwidth (uint8_t dlBandwidth)
+LteUePhy::DoSetDlBandwidth (uint16_t dlBandwidth)
 {
   NS_LOG_FUNCTION (this << (uint32_t) dlBandwidth);
   if (m_dlBandwidth != dlBandwidth or !m_dlConfigured)
@@ -1465,7 +1475,7 @@
 
 
 void 
-LteUePhy::DoConfigureUplink (uint32_t ulEarfcn, uint8_t ulBandwidth)
+LteUePhy::DoConfigureUplink (uint32_t ulEarfcn, uint16_t ulBandwidth)
 {
   m_ulEarfcn = ulEarfcn;
   m_ulBandwidth = ulBandwidth;
@@ -1732,10 +1742,10 @@
 
 
 void
-LteUePhy::ReceiveLteDlHarqFeedback (DlInfoListElement_s m)
+LteUePhy::EnqueueDlHarqFeedback (DlInfoListElement_s m)
 {
   NS_LOG_FUNCTION (this);
-  // generate feedback to eNB and send it through ideal PUCCH
+  // get the feedback from LteSpectrumPhy and send it through ideal PUCCH to eNB
   Ptr<DlHarqFeedbackLteControlMessage> msg = Create<DlHarqFeedbackLteControlMessage> ();
   msg->SetDlHarqFeedback (m);
   SetControlMessages (msg);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ue-rrc.cc ns-3.31/src/lte/model/lte-ue-rrc.cc
--- ns-3.30.1/src/lte/model/lte-ue-rrc.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ue-rrc.cc	2020-06-27 17:38:30.000000000 -0700
@@ -1064,6 +1064,10 @@
         {
           NS_LOG_INFO ("haveMobilityControlInfo == true");
           SwitchToState (CONNECTED_HANDOVER);
+          if (m_radioLinkFailureDetected.IsRunning ())
+            {
+              ResetRlfParams ();
+            }
           const LteRrcSap::MobilityControlInfo& mci = msg.mobilityControlInfo;
           m_handoverStartTrace (m_imsi, m_cellId, m_rnti, mci.targetPhysCellId);
           //We should reset the MACs and PHYs for all the component carriers
@@ -1355,9 +1359,9 @@
 
 
       uint16_t physCellId = scell.cellIdentification.physCellId;
-      uint8_t ulBand = scell.radioResourceConfigCommonSCell.ulConfiguration.ulFreqInfo.ulBandwidth;
+      uint16_t ulBand = scell.radioResourceConfigCommonSCell.ulConfiguration.ulFreqInfo.ulBandwidth;
       uint32_t ulEarfcn = scell.radioResourceConfigCommonSCell.ulConfiguration.ulFreqInfo.ulCarrierFreq;
-      uint8_t dlBand = scell.radioResourceConfigCommonSCell.nonUlConfiguration.dlBandwidth;
+      uint16_t dlBand = scell.radioResourceConfigCommonSCell.nonUlConfiguration.dlBandwidth;
       uint32_t dlEarfcn = scell.cellIdentification.dlCarrierFreq;
       uint8_t txMode = scell.radioResourceConfigDedicateSCell.physicalConfigDedicatedSCell.antennaInfo.transmissionMode;
       uint8_t srsIndex = scell.radioResourceConfigDedicateSCell.physicalConfigDedicatedSCell.soundingRsUlConfigDedicated.srsConfigIndex;
@@ -3072,9 +3076,8 @@
 {
   NS_LOG_FUNCTION (this << m_imsi);
   m_leaveConnectedMode = true;
-  m_radioLinkFailureDetected.Cancel ();
   m_storedMeasValues.clear ();
-  m_noOfSyncIndications = 0;
+  ResetRlfParams ();
 
   std::map<uint8_t, LteRrcSap::MeasIdToAddMod>::iterator measIdIt;
   for (measIdIt = m_varMeasConfig.measIdList.begin ();
@@ -3303,9 +3306,7 @@
   m_phySyncDetectionTrace (m_imsi, m_rnti, m_cellId, "Notify in sync", m_noOfSyncIndications);
   if (m_noOfSyncIndications == m_n311)
     {
-      m_radioLinkFailureDetected.Cancel ();
-      m_noOfSyncIndications = 0;
-      m_cphySapProvider.at (0)->ResetRlfParams ();
+      ResetRlfParams ();
     }
 }
 
@@ -3338,6 +3339,15 @@
   m_noOfSyncIndications = 0;
 }
 
+void
+LteUeRrc::ResetRlfParams ()
+{
+  NS_LOG_FUNCTION (this << m_imsi);
+  m_radioLinkFailureDetected.Cancel ();
+  m_noOfSyncIndications = 0;
+  m_cphySapProvider.at (0)->ResetRlfParams ();
+}
+
 
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ue-rrc.h ns-3.31/src/lte/model/lte-ue-rrc.h
--- ns-3.30.1/src/lte/model/lte-ue-rrc.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ue-rrc.h	2020-06-27 17:38:30.000000000 -0700
@@ -822,8 +822,8 @@
 
   LteRrcSap::PdschConfigDedicated m_pdschConfigDedicated; ///< the PDSCH condig dedicated
 
-  uint8_t m_dlBandwidth; /**< Downlink bandwidth in RBs. */
-  uint8_t m_ulBandwidth; /**< Uplink bandwidth in RBs. */
+  uint16_t m_dlBandwidth; /**< Downlink bandwidth in RBs. */
+  uint16_t m_ulBandwidth; /**< Uplink bandwidth in RBs. */
 
   uint32_t m_dlEarfcn;  /**< Downlink carrier frequency. */
   uint32_t m_ulEarfcn;  /**< Uplink carrier frequency. */
@@ -917,7 +917,7 @@
   /**
    * The `DrbCreated` trace source. Fired when DRB is created, i.e.
    * the RLC and PDCP entities are created for one logical channel.
-   * Exporting IMSI, cell ID, RNTI, and LCID
+   * Exporting IMSI, cell ID, RNTI, LCID.
    */
   TracedCallback<uint64_t, uint16_t, uint16_t, uint8_t> m_drbCreatedTrace;
   /**
@@ -1320,6 +1320,22 @@
    */
   void DoResetSyncIndicationCounter ();
 
+  /**
+   * \brief Reset radio link failure parameters
+   *
+   * RLF timers and counters should be rest upon:
+   *
+   * - If the UE received N311 in Sync indications from the UE
+   *   PHY.
+   * - If the UE receives RRCConnectionReconfiguration including
+   *   the mobilityControlInfo (TS 36.331 sec 5.3.5.4)
+   *
+   * Inside this method the UE RRC also instructs the UE PHY to reset the
+   * RLF parameters so, it can start RLF detection again.
+   *
+   */
+  void ResetRlfParams ();
+
 public:
   /** 
    * The number of component carriers.
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-ffr-simple.cc ns-3.31/src/lte/test/lte-ffr-simple.cc
--- ns-3.30.1/src/lte/test/lte-ffr-simple.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-ffr-simple.cc	2020-06-27 17:38:30.000000000 -0700
@@ -270,7 +270,7 @@
   return 1; // 1 is mapped to 0 for Accumulated mode, and to -1 in Absolute mode TS36.213 Table 5.1.1.1-2
 }
 
-uint8_t
+uint16_t
 LteFfrSimple::DoGetMinContinuousUlBandwidth ()
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-ffr-simple.h ns-3.31/src/lte/test/lte-ffr-simple.h
--- ns-3.30.1/src/lte/test/lte-ffr-simple.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-ffr-simple.h	2020-06-27 17:38:30.000000000 -0700
@@ -113,7 +113,7 @@
   virtual void DoReportUlCqiInfo (const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
   virtual void DoReportUlCqiInfo ( std::map <uint16_t, std::vector <double> > ulCqiMap );
   virtual uint8_t DoGetTpc (uint16_t rnti);
-  virtual uint8_t DoGetMinContinuousUlBandwidth ();
+  virtual uint16_t DoGetMinContinuousUlBandwidth ();
 
   // FFR SAP RRC PROVIDER IMPLEMENTATION
   virtual void DoReportUeMeas (uint16_t rnti, LteRrcSap::MeasResults measResults);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-carrier-aggregation.cc ns-3.31/src/lte/test/lte-test-carrier-aggregation.cc
--- ns-3.30.1/src/lte/test/lte-test-carrier-aggregation.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-carrier-aggregation.cc	2020-06-27 17:38:30.000000000 -0700
@@ -286,6 +286,20 @@
   Config::SetDefault ("ns3::LteSpectrumPhy::DataErrorModelEnabled", BooleanValue (false));
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
 
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlPdcpOutputFilename", StringValue (CreateTempDirFilename ("DlPdcpStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlPdcpOutputFilename", StringValue (CreateTempDirFilename ("UlPdcpStats.txt")));
+  Config::SetDefault ("ns3::PhyStatsCalculator::DlRsrpSinrFilename", StringValue (CreateTempDirFilename ("DlRsrpSinrStats.txt")));
+  Config::SetDefault ("ns3::PhyStatsCalculator::UlSinrFilename", StringValue (CreateTempDirFilename ("UlSinrStats.txt")));
+  Config::SetDefault ("ns3::PhyStatsCalculator::UlInterferenceFilename", StringValue (CreateTempDirFilename ("UlInterferenceStats.txt")));
+  Config::SetDefault ("ns3::PhyRxStatsCalculator::DlRxOutputFilename", StringValue (CreateTempDirFilename ("DlRxPhyStats.txt")));
+  Config::SetDefault ("ns3::PhyRxStatsCalculator::UlRxOutputFilename", StringValue (CreateTempDirFilename ("UlRxPhyStats.txt")));
+  Config::SetDefault ("ns3::PhyTxStatsCalculator::DlTxOutputFilename", StringValue (CreateTempDirFilename ("DlTxPhyStats.txt")));
+  Config::SetDefault ("ns3::PhyTxStatsCalculator::UlTxOutputFilename", StringValue (CreateTempDirFilename ("UlTxPhyStats.txt")));
+
   /**
    * Initialize Simulation Scenario: 1 eNB and m_nUser UEs
    */
@@ -356,7 +370,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the assignation is done in a RR fashion
+   * Check that the assignment is done in a RR fashion
    */
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> dlDataRxed;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-carrier-aggregation.h ns-3.31/src/lte/test/lte-test-carrier-aggregation.h
--- ns-3.30.1/src/lte/test/lte-test-carrier-aggregation.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-carrier-aggregation.h	2020-06-27 17:38:30.000000000 -0700
@@ -94,8 +94,8 @@
 
   uint16_t m_nUser; ///< the number of users
   uint16_t m_dist; ///< the distance
-  uint32_t m_dlBandwidth; ///< DL bandwidth
-  uint32_t m_ulBandwidth; ///< UL bandwidth
+  uint16_t m_dlBandwidth; ///< DL bandwidth
+  uint16_t m_ulBandwidth; ///< UL bandwidth
   uint32_t m_numberOfComponentCarriers; ///< number of component carriers
 
   std::map <uint8_t, uint32_t> m_ccDownlinkTraffic; ///< CC DL traffic
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-cqa-ff-mac-scheduler.cc ns-3.31/src/lte/test/lte-test-cqa-ff-mac-scheduler.cc
--- ns-3.30.1/src/lte/test/lte-test-cqa-ff-mac-scheduler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-cqa-ff-mac-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -274,6 +274,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   Ptr<PointToPointEpcHelper>  epcHelper = CreateObject<PointToPointEpcHelper> ();
@@ -452,7 +456,7 @@
     }
 
   /**
-  * Check that the uplink assignation is done in a "round robin" manner
+  * Check that the uplink assignment is done in a "round robin" manner
   */
 
   NS_LOG_INFO ("UL - Test with " << m_nUser << " user(s) at distance " << m_dist);
@@ -520,7 +524,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
-
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   Ptr<PointToPointEpcHelper>  epcHelper = CreateObject<PointToPointEpcHelper> ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-deactivate-bearer.cc ns-3.31/src/lte/test/lte-test-deactivate-bearer.cc
--- ns-3.30.1/src/lte/test/lte-test-deactivate-bearer.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-deactivate-bearer.cc	2020-06-27 17:38:30.000000000 -0700
@@ -135,7 +135,8 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
-
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   Ptr<PointToPointEpcHelper>  epcHelper = CreateObject<PointToPointEpcHelper> ();
@@ -172,8 +173,9 @@
   // LogComponentEnable ("LteHelper", logLevel);
   // LogComponentEnable ("EpcHelper", logLevel);
   // LogComponentEnable ("EpcEnbApplication", logLevel);
-  // LogComponentEnable ("EpcSgwPgwApplication", logLevel);
-  // LogComponentEnable ("EpcMme", logLevel);
+  // LogComponentEnable ("EpcMmeApplication", logLevel);
+  // LogComponentEnable ("EpcPgwApplication", logLevel);
+  // LogComponentEnable ("EpcSgwApplication", logLevel);
   // LogComponentEnable ("LteEnbRrc", logLevel);
 
   lteHelper->SetAttribute ("PathlossModel", StringValue ("ns3::FriisSpectrumPropagationLossModel"));
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-downlink-power-control.cc ns-3.31/src/lte/test/lte-test-downlink-power-control.cc
--- ns-3.30.1/src/lte/test/lte-test-downlink-power-control.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-downlink-power-control.cc	2020-06-27 17:38:30.000000000 -0700
@@ -356,7 +356,7 @@
  */
 
 LteDownlinkPowerControlSpectrumValueTestCase::LteDownlinkPowerControlSpectrumValueTestCase (std::string name,
-                                                                                            uint16_t earfcn, uint8_t bw, double powerTx,
+                                                                                            uint16_t earfcn, uint16_t bw, double powerTx,
                                                                                             std::map<int, double> powerTxMap, std::vector <int> activeRbs,
                                                                                             SpectrumValue& expected)
   : TestCase ("Downlink Power Control: " + name),
